﻿Version=6.80
NumberOfForms=1
Form1=Form1
NumberOfObjects=2
Object1=Regex1:Regex
Object2=Match1:Match
Sub designer
addform(Form1,"Form1","",220,220,220)@
addstack(form1,stDepth,70,160,80,25)@
addstack(form1,stParent,65,120,80,25)@
addhashtable(form1,htKeys,80,55,80,25)@
End Sub
@EndOfDesignText@
Sub Globals
	Public MAX_NUMBER_OF_RECORDS 'Change this value before parsing for very large files.
	MAX_NUMBER_OF_RECORDS = 20000
	Public Type (Tag, Value, FirstSon, NextSibling) Records(0)
	Public NumberOfRecords
End Sub

Public Sub ParseFile(file)
	Regex1.New1("(\d+) ((@[^@]*@) )?([^ ]+)( (.*))?")
	Match1.New1
	'The records array is resized here to allow changing MAX_NUMBER_OF_RECORDS before parsing
	htKeys.Clear
	Dim Records(MAX_NUMBER_OF_RECORDS, 4) 
	stDepth.Push(-1) 'Add the ROOT node.
	stParent.Push(0)
	Records(0).Tag = "ROOT"
	Records(0).Value = "ROOT"
	NumberOfRecords = 1
	FileOpen(c1, file, cRead)
	'Parse all lines
	line = FileRead(c1)
	Do While line <> EOF
		If Not(ParseLine(line)) Then Exit 
		line = FileRead(c1)
	Loop
	stDepth.Pop 'clear the remaining items in the stack
	stParent.Pop
	stDepth.Pop
	stParent.Pop
	FileClose(c1)
End Sub

Private Sub ParseLine (line)
	'lets find first number
	Match1.Value = Regex1.Match(line)
	If Match1.Success = False Then
		Msgbox("Error parsing line: " & line)
		Return False
	End If
	depth = Match1.GetGroup(1)
	lastDepth = stDepth.Peek
	If depth = lastDepth Then 'Another sibling
		p = stParent.Pop 'Remove previous sibling and add this one as its NextSibling
		stDepth.Pop
		Records(p).NextSibling = NumberOfRecords
	Else If depth < lastDepth Then 'End of previous branch
		d = stDepth.Pop 'Remove all items which depth larger than the current item.
		p = stParent.Pop
		Do While d > depth
			d = stDepth.Pop
			p = stParent.Pop
		Loop
		Records(p).NextSibling = NumberOfRecords
	Else If depth > lastDepth Then 'Current item is a first son.
		p = stParent.Peek
		Records(p).FirstSon = NumberOfRecords
	End If
	Records(NumberOfRecords).Tag = Match1.GetGroup(4)
	Records(NumberOfRecords).Value = Match1.GetGroup(6)
	If match1.GetGroup(3) <> "" Then 'Found a key (@??@), add it to the keys Hashtable
		htKeys.Add(match1.GetGroup(3), NumberOfRecords)
	End If
	stDepth.Push(depth) 'Add current item to the stacks.
	stParent.Push(NumberOfRecords)
	NumberOfRecords = NumberOfRecords + 1
	Return True
End Sub